<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-comment">-- | A mid-level wrapper around the raw C bindings.</span><span>
</span><span id="line-2"></span><span class="hs-comment">--</span><span>
</span><span id="line-3"></span><span class="hs-comment">-- This module is meant to be import qualified as @GPU@ so that its names</span><span>
</span><span id="line-4"></span><span class="hs-comment">-- mirror the C functions (which are prefixed with @GPU_@)</span><span>
</span><span id="line-5"></span><span class="hs-comment">--</span><span>
</span><span id="line-6"></span><span class="hs-comment">-- Here are the &quot;rules&quot; I followed:</span><span>
</span><span id="line-7"></span><span class="hs-comment">-- * All functions run in @forall m. MonadIO m =&gt;@ instead of 'IO' for convenience</span><span>
</span><span id="line-8"></span><span class="hs-comment">-- * 'Ptr' types that are actually references (e.g. 'GPU.Image') stay as 'Ptr's</span><span>
</span><span id="line-9"></span><span class="hs-comment">-- * 'Ptr' types that are adapters for by-reference structs inputs / &quot;outvars&quot;</span><span>
</span><span id="line-10"></span><span class="hs-comment">--   are passed/returned as Haskell types by-value.</span><span>
</span><span id="line-11"></span><span class="hs-comment">-- * 'CString's are replaced with 'String' or 'FilePath' as appropriate</span><span>
</span><span id="line-12"></span><span class="hs-comment">-- * 'GPU.Bool's are replaced with 'Prelude.Bool'</span><span>
</span><span id="line-13"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple</span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html"><span class="hs-identifier">SDL.GPU.C.Types</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html"><span class="hs-identifier">SDL.GPU.C.NumericTypes</span></a></span><span>
</span><span id="line-16"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html"><span class="hs-identifier">SDL.GPU.C.Bool</span></a></span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html"><span class="hs-identifier">SDL.GPU.Simple.ContextControls</span></a></span><span>
</span><span id="line-18"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html"><span class="hs-identifier">SDL.GPU.Simple.Conversions</span></a></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html"><span class="hs-identifier">SDL.GPU.Simple.ImageControls</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html"><span class="hs-identifier">SDL.GPU.Simple.Initialization</span></a></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Logging.html"><span class="hs-identifier">SDL.GPU.Simple.Logging</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html"><span class="hs-identifier">SDL.GPU.Simple.Matrix</span></a></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html"><span class="hs-identifier">SDL.GPU.Simple.RendererControls</span></a></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.RendererSetup.html"><span class="hs-identifier">SDL.GPU.Simple.RendererSetup</span></a></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html"><span class="hs-identifier">SDL.GPU.Simple.Rendering</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ShaderInterface.html"><span class="hs-identifier">SDL.GPU.Simple.ShaderInterface</span></a></span><span>
</span><span id="line-27"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Shapes.html"><span class="hs-identifier">SDL.GPU.Simple.Shapes</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.SurfaceControls.html"><span class="hs-identifier">SDL.GPU.Simple.SurfaceControls</span></a></span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html"><span class="hs-identifier">SDL.GPU.Simple.TargetControls</span></a></span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="hs-keyword">module</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.html"><span class="hs-identifier">SDL.GPU.Simple</span></a></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-operator">(.|.)</span></span><span>
</span><span id="line-32"></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-33"></span><span>
</span><span id="line-34"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Bits</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-operator">(.|.)</span></span><span class="hs-special">)</span><span>
</span><span id="line-35"></span><span>
</span><span id="line-36"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html"><span class="hs-identifier">SDL.GPU.C.Types</span></a></span><span>
</span><span id="line-37"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html"><span class="hs-identifier">SDL.GPU.C.NumericTypes</span></a></span><span>
</span><span id="line-38"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html"><span class="hs-identifier">SDL.GPU.C.Bool</span></a></span><span>
</span><span id="line-39"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html"><span class="hs-identifier">SDL.GPU.Simple.ContextControls</span></a></span><span>
</span><span id="line-40"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Conversions.html"><span class="hs-identifier">SDL.GPU.Simple.Conversions</span></a></span><span>
</span><span id="line-41"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html"><span class="hs-identifier">SDL.GPU.Simple.ImageControls</span></a></span><span>
</span><span id="line-42"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html"><span class="hs-identifier">SDL.GPU.Simple.Initialization</span></a></span><span>
</span><span id="line-43"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Logging.html"><span class="hs-identifier">SDL.GPU.Simple.Logging</span></a></span><span>
</span><span id="line-44"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html"><span class="hs-identifier">SDL.GPU.Simple.Matrix</span></a></span><span>
</span><span id="line-45"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html"><span class="hs-identifier">SDL.GPU.Simple.RendererControls</span></a></span><span>
</span><span id="line-46"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.RendererSetup.html"><span class="hs-identifier">SDL.GPU.Simple.RendererSetup</span></a></span><span>
</span><span id="line-47"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html"><span class="hs-identifier">SDL.GPU.Simple.Rendering</span></a></span><span>
</span><span id="line-48"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.ShaderInterface.html"><span class="hs-identifier">SDL.GPU.Simple.ShaderInterface</span></a></span><span>
</span><span id="line-49"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.Shapes.html"><span class="hs-identifier">SDL.GPU.Simple.Shapes</span></a></span><span>
</span><span id="line-50"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.SurfaceControls.html"><span class="hs-identifier">SDL.GPU.Simple.SurfaceControls</span></a></span><span>
</span><span id="line-51"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html"><span class="hs-identifier">SDL.GPU.Simple.TargetControls</span></a></span><span>
</span><span id="line-52"></span><span>
</span><span id="line-53"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-54"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="SDL.GPU.Simple.html#withMatrix"><span class="hs-identifier hs-type">withMatrix</span></a></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679192403"><span class="annot"><a href="#local-6989586621679192403"><span class="hs-identifier hs-type">m</span></a></span></span><span> </span><span id="local-6989586621679192399"><span class="annot"><a href="#local-6989586621679192399"><span class="hs-identifier hs-type">r</span></a></span></span><span>
</span><span id="line-58"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679192403"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">Target</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#MatrixMode"><span class="hs-identifier hs-type">MatrixMode</span></a></span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192403"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192399"><span class="hs-identifier hs-type">r</span></a></span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192403"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192399"><span class="hs-identifier hs-type">r</span></a></span><span>
</span><span id="line-63"></span><span id="withMatrix"><span class="annot"><span class="annottext">withMatrix :: forall (m :: * -&gt; *) r.
MonadIO m =&gt;
Ptr Target -&gt; MatrixMode -&gt; m r -&gt; m r
</span><a href="SDL.GPU.Simple.html#withMatrix"><span class="hs-identifier hs-var hs-var">withMatrix</span></a></span></span><span> </span><span id="local-6989586621679192362"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679192362"><span class="hs-identifier hs-var">screen</span></a></span></span><span> </span><span id="local-6989586621679192361"><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679192361"><span class="hs-identifier hs-var">mode</span></a></span></span><span> </span><span id="local-6989586621679192360"><span class="annot"><span class="annottext">m r
</span><a href="#local-6989586621679192360"><span class="hs-identifier hs-var">k</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-64"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; MatrixMode -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#matrixMode"><span class="hs-identifier hs-var">matrixMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679192362"><span class="hs-identifier hs-var">screen</span></a></span><span> </span><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679192361"><span class="hs-identifier hs-var">mode</span></a></span><span>
</span><span id="line-65"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#pushMatrix"><span class="hs-identifier hs-var">pushMatrix</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span id="local-6989586621679192357"><span class="annot"><span class="annottext">r
</span><a href="#local-6989586621679192357"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">m r
</span><a href="#local-6989586621679192360"><span class="hs-identifier hs-var">k</span></a></span><span>
</span><span id="line-67"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; MatrixMode -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#matrixMode"><span class="hs-identifier hs-var">matrixMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679192362"><span class="hs-identifier hs-var">screen</span></a></span><span> </span><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679192361"><span class="hs-identifier hs-var">mode</span></a></span><span>
</span><span id="line-68"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#popMatrix"><span class="hs-identifier hs-var">popMatrix</span></a></span><span>
</span><span id="line-69"></span><span>  </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="annot"><span class="annottext">r
</span><a href="#local-6989586621679192357"><span class="hs-identifier hs-var">r</span></a></span><span>
</span><span id="line-70"></span><span>
</span><span id="line-71"></span><span class="annot"><a href="SDL.GPU.Simple.html#withFreshMatrix"><span class="hs-identifier hs-type">withFreshMatrix</span></a></span><span>
</span><span id="line-72"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679192354"><span class="annot"><a href="#local-6989586621679192354"><span class="hs-identifier hs-type">m</span></a></span></span><span> </span><span id="local-6989586621679192353"><span class="annot"><a href="#local-6989586621679192353"><span class="hs-identifier hs-type">r</span></a></span></span><span>
</span><span id="line-73"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679192354"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-74"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">Target</span></a></span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#MatrixMode"><span class="hs-identifier hs-type">MatrixMode</span></a></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192354"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192353"><span class="hs-identifier hs-type">r</span></a></span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192354"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192353"><span class="hs-identifier hs-type">r</span></a></span><span>
</span><span id="line-78"></span><span id="withFreshMatrix"><span class="annot"><span class="annottext">withFreshMatrix :: forall (m :: * -&gt; *) r.
MonadIO m =&gt;
Ptr Target -&gt; MatrixMode -&gt; m r -&gt; m r
</span><a href="SDL.GPU.Simple.html#withFreshMatrix"><span class="hs-identifier hs-var hs-var">withFreshMatrix</span></a></span></span><span> </span><span id="local-6989586621679192347"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679192347"><span class="hs-identifier hs-var">screen</span></a></span></span><span> </span><span id="local-6989586621679192346"><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679192346"><span class="hs-identifier hs-var">mode</span></a></span></span><span> </span><span id="local-6989586621679192345"><span class="annot"><span class="annottext">m r
</span><a href="#local-6989586621679192345"><span class="hs-identifier hs-var">k</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) r.
MonadIO m =&gt;
Ptr Target -&gt; MatrixMode -&gt; m r -&gt; m r
</span><a href="SDL.GPU.Simple.html#withMatrix"><span class="hs-identifier hs-var">withMatrix</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679192347"><span class="hs-identifier hs-var">screen</span></a></span><span> </span><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679192346"><span class="hs-identifier hs-var">mode</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#loadIdentity"><span class="hs-identifier hs-var">loadIdentity</span></a></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; m b -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">m r
</span><a href="#local-6989586621679192345"><span class="hs-identifier hs-var">k</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="annot"><a href="SDL.GPU.Simple.html#withAliasImage"><span class="hs-identifier hs-type">withAliasImage</span></a></span><span>
</span><span id="line-81"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679192386"><span class="annot"><a href="#local-6989586621679192386"><span class="hs-identifier hs-type">m</span></a></span></span><span> </span><span id="local-6989586621679192384"><span class="annot"><a href="#local-6989586621679192384"><span class="hs-identifier hs-type">r</span></a></span></span><span>
</span><span id="line-82"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679192386"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-83"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">Image</span></a></span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">Image</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192386"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192384"><span class="hs-identifier hs-type">r</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-85"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679192386"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679192384"><span class="hs-identifier hs-type">r</span></a></span><span>
</span><span id="line-86"></span><span id="withAliasImage"><span class="annot"><span class="annottext">withAliasImage :: forall (m :: * -&gt; *) r.
MonadIO m =&gt;
Ptr Image -&gt; (Ptr Image -&gt; m r) -&gt; m r
</span><a href="SDL.GPU.Simple.html#withAliasImage"><span class="hs-identifier hs-var hs-var">withAliasImage</span></a></span></span><span> </span><span id="local-6989586621679192333"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679192333"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679192332"><span class="annot"><span class="annottext">Ptr Image -&gt; m r
</span><a href="#local-6989586621679192332"><span class="hs-identifier hs-var">k</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-87"></span><span>  </span><span id="local-6989586621679192331"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679192331"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#createAliasImage"><span class="hs-identifier hs-var">createAliasImage</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679192333"><span class="hs-identifier hs-var">img</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span id="local-6989586621679192329"><span class="annot"><span class="annottext">r
</span><a href="#local-6989586621679192329"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; m r
</span><a href="#local-6989586621679192332"><span class="hs-identifier hs-var">k</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679192331"><span class="hs-identifier hs-var">a</span></a></span><span>
</span><span id="line-89"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#freeImage"><span class="hs-identifier hs-var">freeImage</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679192331"><span class="hs-identifier hs-var">a</span></a></span><span>
</span><span id="line-90"></span><span>  </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="annot"><span class="annottext">r
</span><a href="#local-6989586621679192329"><span class="hs-identifier hs-var">r</span></a></span><span>
</span><span id="line-91"></span></pre></body></html>